package cn.ibizlab.core.uaa.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.HashSet;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.uaa.domain.SYS_ROLE_PERMISSION;
import cn.ibizlab.core.uaa.filter.SYS_ROLE_PERMISSIONSearchContext;
import cn.ibizlab.core.uaa.service.ISYS_ROLE_PERMISSIONService;

import cn.ibizlab.util.helper.CachedBeanCopier;



import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.core.uaa.mapper.SYS_ROLE_PERMISSIONMapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.alibaba.fastjson.JSONObject;


/**
 * 实体[角色权限关系] 服务对象接口实现
 */
@Slf4j
@Service
public class SYS_ROLE_PERMISSIONServiceImpl extends ServiceImpl<SYS_ROLE_PERMISSIONMapper, SYS_ROLE_PERMISSION> implements ISYS_ROLE_PERMISSIONService {

    private int batchSize = 500;

    @Override
    @Transactional
    public SYS_ROLE_PERMISSION get(String key) {
        SYS_ROLE_PERMISSION et = getById(key);
        if(et==null){
            et=new SYS_ROLE_PERMISSION();
            et.setRolepermissionid(key);
        }
        else{
        }
        return et;
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        if(!removeById(key)) return false;
        return true ;
    }

    @Override
    public void removeBatch(Collection<String> idList) {
        removeByIds(idList);
    }

    @Override
    public SYS_ROLE_PERMISSION getDraft(SYS_ROLE_PERMISSION et) {
        return et;
    }

    @Override
    @Transactional
    public boolean create(SYS_ROLE_PERMISSION et) {
        if(!this.retBool(this.baseMapper.insert(et)))
            return false;
        CachedBeanCopier.copy(get(et.getRolepermissionid()),et);
        return true;
    }

    @Override
    public void createBatch(List<SYS_ROLE_PERMISSION> list) {
        saveBatch(list,batchSize);
    }

    @Override
    public boolean checkKey(SYS_ROLE_PERMISSION et) {
        return (!ObjectUtils.isEmpty(et.getRolepermissionid()))&&(!Objects.isNull(this.getById(et.getRolepermissionid())));
    }

    @Override
    @Transactional
    public boolean save(SYS_ROLE_PERMISSION et) {
        if(!saveOrUpdate(et))
            return false;
        return true;
    }

    @Override
    @Transactional(
            rollbackFor = {Exception.class}
    )
    public boolean saveOrUpdate(SYS_ROLE_PERMISSION et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? this.update(et) : this.create(et);
        }
    }

    @Override
    public void saveBatch(List<SYS_ROLE_PERMISSION> list) {
        saveOrUpdateBatch(list,batchSize);
    }

    @Override
    @Transactional
    public boolean update(SYS_ROLE_PERMISSION et) {
        if(!update(et,(Wrapper) et.getUpdateWrapper(true).eq("sys_role_permissionid",et.getRolepermissionid())))
            return false;
        CachedBeanCopier.copy(get(et.getRolepermissionid()),et);
        return true;
    }

    @Override
    public void updateBatch(List<SYS_ROLE_PERMISSION> list) {
        updateBatchById(list,batchSize);
    }


	@Override
    public List<SYS_ROLE_PERMISSION> selectByPermissionid(String permissionid) {
        return baseMapper.selectByPermissionid(permissionid);
    }

    @Override
    public void removeByPermissionid(String permissionid) {
        this.remove(new QueryWrapper<SYS_ROLE_PERMISSION>().eq("sys_permissionid",permissionid));
    }

	@Override
    public void saveByPermissionid(String permissionid,List<SYS_ROLE_PERMISSION> list) {
        if(list==null)
            return;
        Set<String> delIds=new HashSet<String>();
        List<SYS_ROLE_PERMISSION> _update=new ArrayList<SYS_ROLE_PERMISSION>();
        List<SYS_ROLE_PERMISSION> _create=new ArrayList<SYS_ROLE_PERMISSION>();
        for(SYS_ROLE_PERMISSION before:selectByPermissionid(permissionid)){
            delIds.add(before.getRolepermissionid());
        }
        for(SYS_ROLE_PERMISSION sub:list) {
            sub.setPermissionid(permissionid);
            if(ObjectUtils.isEmpty(sub.getRolepermissionid()))
                sub.setRolepermissionid((String)sub.getDefaultKey(true));
            if(delIds.contains(sub.getRolepermissionid())) {
                delIds.remove(sub.getRolepermissionid());
                _update.add(sub);
            }
            else
                _create.add(sub);
        }
        if(_update.size()>0)
            this.updateBatch(_update);
        if(_create.size()>0)
            this.createBatch(_create);
        if(delIds.size()>0)
            this.removeBatch(delIds);
	}

	@Override
    public List<SYS_ROLE_PERMISSION> selectByRoleid(String roleid) {
        return baseMapper.selectByRoleid(roleid);
    }

    @Override
    public void removeByRoleid(String roleid) {
        this.remove(new QueryWrapper<SYS_ROLE_PERMISSION>().eq("sys_roleid",roleid));
    }

	@Override
    public void saveByRoleid(String roleid,List<SYS_ROLE_PERMISSION> list) {
        if(list==null)
            return;
        Set<String> delIds=new HashSet<String>();
        List<SYS_ROLE_PERMISSION> _update=new ArrayList<SYS_ROLE_PERMISSION>();
        List<SYS_ROLE_PERMISSION> _create=new ArrayList<SYS_ROLE_PERMISSION>();
        for(SYS_ROLE_PERMISSION before:selectByRoleid(roleid)){
            delIds.add(before.getRolepermissionid());
        }
        for(SYS_ROLE_PERMISSION sub:list) {
            sub.setRoleid(roleid);
            if(ObjectUtils.isEmpty(sub.getRolepermissionid()))
                sub.setRolepermissionid((String)sub.getDefaultKey(true));
            if(delIds.contains(sub.getRolepermissionid())) {
                delIds.remove(sub.getRolepermissionid());
                _update.add(sub);
            }
            else
                _create.add(sub);
        }
        if(_update.size()>0)
            this.updateBatch(_update);
        if(_create.size()>0)
            this.createBatch(_create);
        if(delIds.size()>0)
            this.removeBatch(delIds);
	}


    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<SYS_ROLE_PERMISSION> searchDefault(SYS_ROLE_PERMISSIONSearchContext context) {
        com.baomidou.mybatisplus.extension.plugins.pagination.Page<SYS_ROLE_PERMISSION> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
        return new PageImpl<SYS_ROLE_PERMISSION>(pages.getRecords(), context.getPageable(), pages.getTotal());
    }


    @Override
    public List<JSONObject> select(String sql){
        return this.baseMapper.selectBySQL(sql);
    }

    @Override
    @Transactional
    public boolean execute(String sql){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

}


